<!-- 
  IT Generation
  Andriy Andrusevych
  HW 12
  Обмін валют
  
  Частину коду взяв тут https://www.w3schools.com/howto/howto_js_autocomplete.asp
  і адаптував його до завдання (код для підказки тексту введення на input)
  
-->
<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="UTF-8">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Document</title>

  <style>
    * {
      box-sizing: border-box;
    }

    body {
      margin: 0 auto;
    }


    .header {
      margin: 20px auto;
      text-align: center;
    }

    .wrapper {
      display: flex;
      flex-direction: row;
      align-items: flex-start;
      margin-bottom: 30px;
      justify-content: center;
    }

    input[type="number"] {
      background-color: antiquewhite;
      margin-left: 5px;
      margin-right: 5px;
      color: blue;
    }

    input {
      border: 1px solid transparent;
      background-color: #f1f1f1;
      padding: 10px;
      font-size: 16px;
    }

    input[type=text] {
      background-color: #f1f1f1;
      width: 100%;
    }

    input[type=button] {
      color: blueviolet;
      width: 45px;
      cursor: pointer;
      /* height: input[height]; */

    }

    .output {
      background-color: antiquewhite;
      margin-left: 5px;
      margin-right: 5px;
      width: 200px;
      height: 40px;
      padding: 10px;
      display: flex;
      justify-content: center;
      color: rebeccapurple;
      font-weight: bold;

    }

    .grid {
      display: grid;
      grid-template-columns: 1fr 1fr;
    }

    .grid_item {
      display: flex;
      padding: 10px;
      justify-content: space-between;
      border: 1px solid black;
    }

    #myInput {
      color: blue;
    }

    #myInput2 {
      color: rebeccapurple;
    }

    .autocomplete {
      position: relative;
      display: inline-block;
      width: 150px;
    }

    .autocomplete-items {
      position: absolute;
      border: 1px solid #d4d4d4;
      border-bottom: none;
      border-top: none;
      z-index: 99;
      /*position the autocomplete items to be the same width as the container:*/
      top: 100%;
      left: 0;
      right: 0;
    }

    .autocomplete-items div {
      padding: 10px;
      cursor: pointer;
      background-color: #fff;
      border-bottom: 1px solid #d4d4d4;
    }

    /*when hovering an item:*/
    .autocomplete-items div:hover {
      background-color: #e9e9e9;
    }

    /*when navigating through the items using the arrow keys:*/
    .autocomplete-active {
      background-color: DodgerBlue !important;
      color: #ffffff;
    }
  </style>
</head>

<body>
  <div class="header"></div>

  <div class="wrapper">
    <div class="autocomplete">
      <input class="inpMy" id="myInput" type="text" name="myCurrency" placeholder="From Currency">
    </div>
    <input class="amount" type="number">
    <div class="autocomplete">
      <input class="inpMy" id="myInput2" type="text" name="myCurrency" placeholder="To Currency">
    </div>
    <div class="output">0.00</div>
    <input type="button" value="&#8596">

  </div>

  <div class="grid"></div>


  <script>

    const grid = document.querySelector('.grid');
    const header = document.querySelector('.header');
    const currency1 = document.querySelector(".currency1");
    const input = document.querySelector(".amount");
    const output = document.querySelector(".output");
    const toggle = document.querySelector("input[type='button']");
    let chosenCurrency1;
    let chosenCurrency2;
    let currencies = [];
    let inpMy = document.getElementById('myInput');
    let inpMy2 = document.getElementById('myInput2');
    let data;

    fetch('https://bank.gov.ua/NBUStatService/v1/statdirectory/exchange?json')
      .then(response => response.json())
      .then(json => data = json)

    setTimeout(function () {
      header.innerHTML = data[0].exchangedate;

      data.forEach(element => {
        currencies.push(element.cc + ' ' + element.txt);
        grid.insertAdjacentHTML('beforeend',
        `<div class="grid_item">
          <div class="grid_cc">${element.cc}</div>
          <div class="grid_txt">${element.txt}</div>
          <div class="grid_rate">${element.rate}</div>
        </div>`);
      });
     
    }, 400);

    input.addEventListener("input", () => {
      getResult()
    });

    toggle.addEventListener("click", () => {
      let from = inpMy2.value;
      inpMy2.value = inpMy.value;
      inpMy.value = from;
      getResult()
    })

    function getResult() {
      let fromRate;
      let toRate;
      let result;
      if (input !=0 && inpMy.value !='' && inpMy2.value !='') {
        console.log('result started');
        data.forEach(element => {
          if (element.cc == inpMy.value.substr(0, 3).toUpperCase()) {
            fromRate = element.rate;
          }
          if (element.cc == inpMy2.value.substr(0, 3).toUpperCase()) {
            toRate = element.rate;
          }
        });
        let result = fromRate / toRate * input.value;
        output.innerHTML = result.toFixed(2);
      }
    }
    function autocomplete(inp, arr) {
      var currentFocus;
      /*execute a function when someone writes in the text field:*/
      inp.addEventListener("input", function (e) {
        var a, b, i, val = this.value;
        /*close any already open lists of autocompleted values*/
        closeAllLists();
        if (!val) { return false; }
        currentFocus = -1;
        /*create a DIV element that will contain the items (values):*/
        a = document.createElement("DIV");
        a.setAttribute("id", this.id + "autocomplete-list");
        a.setAttribute("class", "autocomplete-items");
        /*append the DIV element as a child of the autocomplete container:*/
        this.parentNode.appendChild(a);
        /*for each item in the array...*/
        for (i = 0; i < arr.length; i++) {
          /*check if the item starts with the same letters as the text field value:*/
          if (arr[i].substr(0, val.length).toUpperCase() == val.toUpperCase() |
            /*or it includes the same letters in second part as the text field value:*/
            arr[i].substr(4, val.length).toUpperCase() == val.toUpperCase()) {
            /*create a DIV element for each matching element:*/
            b = document.createElement("DIV");
            /*make the matching letters bold:*/
            b.innerHTML = "<strong>" + arr[i].substr(0, val.length) + "</strong>";
            b.innerHTML += arr[i].substr(val.length);
            /*insert a input field that will hold the current array item's value:*/
            b.innerHTML += "<input type='hidden' value='" + arr[i] + "'>";
            /*execute a function when someone clicks on the item value (DIV element):*/
            b.addEventListener("click", function (e) {
              /*insert the value for the autocomplete text field:*/
              inp.value = this.getElementsByTagName("input")[0].value;
              getResult()
              /*close the list of autocompleted values,
              (or any other open lists of autocompleted values:*/
              closeAllLists();
            });
            a.appendChild(b);
          }
        }
      });
      /*execute a function presses a key on the keyboard:*/
      inp.addEventListener("keydown", function (e) {
        var x = document.getElementById(this.id + "autocomplete-list");
        if (x) x = x.getElementsByTagName("div");
        if (e.keyCode == 40) {
          /*If the arrow DOWN key is pressed,
          increase the currentFocus variable:*/
          currentFocus++;
          /*and and make the current item more visible:*/
          addActive(x);
        } else if (e.keyCode == 38) { //up
          /*If the arrow UP key is pressed,
          decrease the currentFocus variable:*/
          currentFocus--;
          /*and and make the current item more visible:*/
          addActive(x);
        } else if (e.keyCode == 13) {
          /*If the ENTER key is pressed, prevent the form from being submitted,*/
          e.preventDefault();
          if (currentFocus > -1) {
            /*and simulate a click on the "active" item:*/
            if (x) x[currentFocus].click();
          }
        }
      });

      function addActive(x) {
        /*a function to classify an item as "active":*/
        if (!x) return false;
        /*start by removing the "active" class on all items:*/
        removeActive(x);
        if (currentFocus >= x.length) currentFocus = 0;
        if (currentFocus < 0) currentFocus = (x.length - 1);
        /*add class "autocomplete-active":*/
        x[currentFocus].classList.add("autocomplete-active");
        getResult()
      }
      function removeActive(x) {
        /*a function to remove the "active" class from all autocomplete items:*/
        for (var i = 0; i < x.length; i++) {
          x[i].classList.remove("autocomplete-active");
        }
      }
      function closeAllLists(elmnt) {
        /*close all autocomplete lists in the document,
        except the one passed as an argument:*/
        var x = document.getElementsByClassName("autocomplete-items");
        for (var i = 0; i < x.length; i++) {
          if (elmnt != x[i] && elmnt != inp) {
            x[i].parentNode.removeChild(x[i]);
          }
        }
      }
      /*execute a function when someone clicks in the document:*/
      document.addEventListener("click", function (e) {
        closeAllLists(e.target);
      });
    }

    /*initiate the autocomplete function on the "myInput" element, and pass along the countries array as possible autocomplete values:*/
    autocomplete(document.getElementById("myInput"), currencies);
    autocomplete(document.getElementById("myInput2"), currencies);

  </script>
</body>

</html>
